// ==============================================================
//	This file is part of Glest Shared Library (www.glest.org)
//
//	Copyright (C) 2001-2005 Martio Figueroa
//
//	You can redistribute this code and/or modify it under 
//	the terms of the GNU General Public License as published 
//	by the Free Software Foundation; either version 2 of the 
//	License, or (at your option) any later version
// ==============================================================

#ifndef _SHARED_GRAPHICS_GRAPHICSFACTORY_H_
#define _SHARED_GRAPHICS_GRAPHICSFACTORY_H_

namespace Shared{ namespace Graphics{

class TextRenderer2D;
class TextRenderer3D;
class ModelRenderer;
class ParticleRenderer;
class Context;
class Model;
class Texture1D;
class Texture2D;
class Texture3D;
class TextureCube;
class Font2D;
class Font3D;
class ShaderProgram;
class VertexShader;
class FragmentShader;

// =====================================================
//	class GraphicsFactory
// =====================================================

class GraphicsFactory{
public:
	virtual ~GraphicsFactory(){}
	virtual TextRenderer2D *newTextRenderer2D()					{return NULL;}
	virtual TextRenderer3D *newTextRenderer3D()					{return NULL;}
	virtual ModelRenderer *newModelRenderer()					{return NULL;}
	virtual ParticleRenderer *newParticleRenderer()				{return NULL;}
	virtual Context *newContext()								{return NULL;}
	virtual Model *newModel()									{return NULL;}
	virtual Texture1D *newTexture1D()							{return NULL;}
	virtual Texture2D *newTexture2D()							{return NULL;}
	virtual Texture3D *newTexture3D()							{return NULL;}
	virtual TextureCube *newTextureCube()						{return NULL;}
	virtual Font2D *newFont2D()									{return NULL;}
	virtual Font3D *newFont3D()									{return NULL;}
	virtual ShaderProgram *newShaderProgram()					{return NULL;}
	virtual VertexShader *newVertexShader()						{return NULL;}
	virtual FragmentShader *newFragmentShader()					{return NULL;}
};

}}//end namespace

#endif
